/* Sistemas Integrados TEKNISA
   Gesto Consolidada

Nome: 0014_SQLTEKO_ETLATENDTEK.sql
                                                                            
Descrio:                                                                 
Script para criao das tabelas ETLATENDTEK e ETLCONATETEK.

Criao:                                                                   
26/02/2007 Raphael Ernani
Modificao:
02/12/2009 Sara Moitinho
*/


CREATE TABLE ETLATENDTEK
   (	CDFILIAL 	VARCHAR2(4),
	CDANOBI	 	VARCHAR2(4),
	CDMESBI	 	VARCHAR2(2),
	BIFATATEND 	VARCHAR2(6),
	TRFATATEND 	VARCHAR2(6),
	SEFATATEND 	VARCHAR2(6),
	CDOPERADOR 	VARCHAR2(12),
	CDASSUNTO 	VARCHAR2(5),
	CDPRODUTO 	VARCHAR2(10),
        CDFORMACOMU     VARCHAR2(2),
	CDCLIENTE 	VARCHAR2(21),
        NMINTATIVTAR    VARCHAR2(50),
	IDSTATUSATEND 	VARCHAR2(20),
	QTATEATEND 	FLOAT(126),
	QTTMPATEND 	FLOAT(126),
	CDSETOR 	VARCHAR2(4),
        HRDIAATEND      VARCHAR2(30)
   )
/


CREATE INDEX GSC99078 ON ETLATENDTEK (CDOPERADOR)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99078OPERADOR FOREIGN KEY  (CDOPERADOR)
       REFERENCES OPERADOR (CDOPERADOR)
/

CREATE INDEX GSC99079 ON ETLATENDTEK (CDCLIENTE)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99079CLIENTE FOREIGN KEY  (CDCLIENTE)
       REFERENCES CLIENTE (CDCLIENTE)
/

CREATE INDEX GSC99080 ON ETLATENDTEK (CDPRODUTO)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99080PRODUTO FOREIGN KEY  (CDPRODUTO)
       REFERENCES PRODUTO (CDPRODUTO)
/

CREATE INDEX GSC99081 ON ETLATENDTEK (CDANOBI)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99081ANO FOREIGN KEY  (CDANOBI)
       REFERENCES ETLANOBI (CDANOBI)
/

CREATE INDEX GSC99082 ON ETLATENDTEK (CDMESBI)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99082MES FOREIGN KEY  (CDMESBI)
       REFERENCES ETLMESBI (CDMESBI)
/

CREATE INDEX GSC99083 ON ETLATENDTEK (CDASSUNTO)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99083ASSUNTO FOREIGN KEY  (CDASSUNTO)
       REFERENCES ASSUNTO (CDASSUNTO)
/

CREATE INDEX GSC99084 ON ETLATENDTEK (CDFILIAL)
/

ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99084FILIAL FOREIGN KEY  (CDFILIAL)
       REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX GSC99085 ON ETLATENDTEK (CDSETOR)
/


ALTER TABLE ETLATENDTEK
    ADD CONSTRAINT GSC99085ASSUNTO FOREIGN KEY  (CDSETOR)
       REFERENCES SETOR (CDSETOR)
/

  CREATE TABLE ETLCONATETEK
   (	CDFILIAL 	VARCHAR2(4),
	CDANOBI	 	VARCHAR2(4),
	CDMESBI	 	VARCHAR2(2),
	BICONATEND 	VARCHAR2(6),
	TRCONATEND 	VARCHAR2(6),
	SECONATEND 	VARCHAR2(6),
	CDOPERADOR 	VARCHAR2(12),
	CDASSUNTO 	VARCHAR2(5),
	CDPRODUTO 	VARCHAR2(10),
	CDCLIENTE 	VARCHAR2(21),
	IDSTATUSATEND 	VARCHAR2(20),
	QTCONATEND 	FLOAT(126),
	TRESATEND 	FLOAT(126),
	QTTMPCONATEN 	FLOAT(126),
	QTTMPRESATEN 	FLOAT(126),
        QTRESATEND      FLOAT(126),
	CDSETOR 	VARCHAR2(4)
   )
/


CREATE INDEX GSC99070 ON ETLCONATETEK (CDOPERADOR)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99070OPERADOR FOREIGN KEY  (CDOPERADOR)
       REFERENCES OPERADOR (CDOPERADOR)
/

CREATE INDEX GSC99071 ON ETLCONATETEK (CDCLIENTE)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99071CLIENTE FOREIGN KEY  (CDCLIENTE)
       REFERENCES CLIENTE (CDCLIENTE)
/

CREATE INDEX GSC99072 ON ETLCONATETEK (CDPRODUTO)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99072PRODUTO FOREIGN KEY  (CDPRODUTO)
       REFERENCES PRODUTO (CDPRODUTO)
/

CREATE INDEX GSC99073 ON ETLCONATETEK (CDANOBI)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99073ANO FOREIGN KEY  (CDANOBI)
       REFERENCES ETLANOBI (CDANOBI)
/

CREATE INDEX GSC99074 ON ETLCONATETEK (CDMESBI)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99474MES FOREIGN KEY  (CDMESBI)
       REFERENCES ETLMESBI (CDMESBI)
/

CREATE INDEX GSC99075 ON ETLCONATETEK (CDASSUNTO)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99075ASSUNTO FOREIGN KEY  (CDASSUNTO)
       REFERENCES ASSUNTO (CDASSUNTO)
/

CREATE INDEX GSC99076 ON ETLCONATETEK (CDFILIAL)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99076FILIAL FOREIGN KEY  (CDFILIAL)
       REFERENCES FILIAL (CDFILIAL)
/

CREATE INDEX GSC99077 ON ETLCONATETEK (CDSETOR)
/

ALTER TABLE ETLCONATETEK
    ADD CONSTRAINT GSC99077ASSUNTO FOREIGN KEY  (CDSETOR)
       REFERENCES SETOR (CDSETOR)
/

ALTER TABLE ETLATENDTEK
  ADD NMCLIENTE VARCHAR2(50);
/
ALTER TABLE ETLATENDTEK
  ADD DSTPATEND VARCHAR2(7);
/
ALTER TABLE ETLATENDTEK
  ADD VRPERCATEND FLOAT;
/
ALTER TABLE ETLATENDTEK
  ADD VRPERCTMPATEND FLOAT
/
ALTER TABLE ETLATENDTEK
  ADD DSSITUACAO VARCHAR2(15);
/
BEGIN ATUVEROBJ('ATUALIZACAO_ESTRUTURA_BD','0.00.000'); END;

/