/* Sistemas Integrados TECNISA

Nome: 5031_FISTRGO.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   22/06/2012 - Marcelo Alexsandro

Tabela IMPREGRAFISCAL: Regra Fiscal.
Descrio: A trigger insere registros na tabela LOGREGRAFISCAL a partir de alteraes na tabela IMPREGRAFISCAL
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_FIS_IMPREGRAFISCAL' AND
                 TYPE   = 'TR' 	           AND
	              U.UID  = O.UID             AND
	              U.NAME = USER)
DROP TRIGGER LOG_FIS_IMPREGRAFISCAL
GO

CREATE TRIGGER LOG_FIS_IMPREGRAFISCAL
ON IMPREGRAFISCAL
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO    VARCHAR(40);
   DECLARE @V_DTOPER     DATETIME;

   DECLARE @V_ID_COMANDO VARCHAR(1);
   DECLARE @V_DESC       VARCHAR(350);
   DECLARE @V_ITPESQ     VARCHAR(40);
   DECLARE @V_NMOPERADOR VARCHAR(40);
   DECLARE @V_IDTIPOOPER VARCHAR(1);

   DECLARE @V_CDREGRAFISC_OLD      VARCHAR(10);
   DECLARE @V_CDIMPOSTO_OLD        VARCHAR(2);
   DECLARE @V_IDIMPOBRIGREGRA_OLD  VARCHAR(1);

   DECLARE @V_CDREGRAFISC_NEW      VARCHAR(10);
   DECLARE @V_CDIMPOSTO_NEW        VARCHAR(2);
   DECLARE @V_IDIMPOBRIGREGRA_NEW  VARCHAR(1);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/
   SET @V_DESC       = '';
   SET @V_ITPESQ     = '';
   SET @V_NMOPERADOR = '';
   SET @V_IDTIPOOPER = '';

   EXEC NMUSUARIO @V_NMOPERADOR;
   SET @V_NMOPERADOR = ISNULL(@V_NMOPERADOR, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT
     'D' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.CDIMPOSTO,
     DELETED.IDIMPOBRIGREGRA,
     NULL,
     NULL,
     NULL
   FROM
     DELETED
   WHERE
     CDREGRAFISC+CDIMPOSTO NOT IN (SELECT CDREGRAFISC+CDIMPOSTO FROM INSERTED)

   UNION ALL

   SELECT
     'U' IDCOMANDO,
     DELETED.CDREGRAFISC,
     DELETED.CDIMPOSTO,
     DELETED.IDIMPOBRIGREGRA,
     INSERTED.CDREGRAFISC,
     INSERTED.CDIMPOSTO,
     INSERTED.IDIMPOBRIGREGRA
   FROM
      INSERTED,
      DELETED
   WHERE INSERTED.CDREGRAFISC = DELETED.CDREGRAFISC
     AND INSERTED.CDIMPOSTO = DELETED.CDIMPOSTO

   UNION ALL

   SELECT
     'I' IDCOMANDO,
     NULL,
     NULL,
     NULL,
     INSERTED.CDREGRAFISC,
     INSERTED.CDIMPOSTO,
     INSERTED.IDIMPOBRIGREGRA
   FROM INSERTED
   WHERE CDREGRAFISC+CDIMPOSTO NOT IN (SELECT CDREGRAFISC+CDIMPOSTO FROM DELETED);
   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDREGRAFISC_OLD,
                                 @V_CDIMPOSTO_OLD,
                                 @V_IDIMPOBRIGREGRA_OLD,
                                 @V_CDREGRAFISC_NEW,
                                 @V_CDIMPOSTO_NEW,
                                 @V_IDIMPOBRIGREGRA_NEW;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'U' BEGIN
         SET @V_DESC = 'Imposto Obrigatorio = ' + @V_IDIMPOBRIGREGRA_NEW;
         SET @V_ITPESQ = @V_CDREGRAFISC_NEW+@V_CDIMPOSTO_NEW;
         SET @V_IDTIPOOPER = '2';
      END
      ELSE BEGIN
         IF @V_ID_COMANDO = 'I' BEGIN
            SET @V_DESC = 'Imposto Obrigatorio = ' + @V_IDIMPOBRIGREGRA_NEW;
            SET @V_ITPESQ = @V_CDREGRAFISC_NEW+@V_CDIMPOSTO_NEW;
            SET @V_IDTIPOOPER = '1';
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'D' BEGIN
               SET @V_DESC = 'Imposto Obrigatorio = ' + @V_IDIMPOBRIGREGRA_OLD;
               SET @V_ITPESQ = @V_CDREGRAFISC_OLD+@V_CDIMPOSTO_OLD;
               SET @V_IDTIPOOPER = '3';
            END;
         END;
      END;
      INSERT INTO LOGREGRAFISCAL
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          DSOPERACAO,
          CDPESQITEM)
       VALUES
         ('IMPREGRAFISCAL',
          GETDATE(),
          ISNULL(@V_NMOPERADOR,' '),
          @V_IDTIPOOPER,
          @V_DESC,
          @V_ITPESQ);
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDREGRAFISC_OLD,
                                    @V_CDIMPOSTO_OLD,
                                    @V_IDIMPOBRIGREGRA_OLD,
                                    @V_CDREGRAFISC_NEW,
                                    @V_CDIMPOSTO_NEW,
                                    @V_IDIMPOBRIGREGRA_NEW;
   END;
   CLOSE C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_IMPREGRAFISCAL','5.30.xxx';
GO
